//
// IFalpService.aidl
//
// Copyright 2010 FeliCa Networks, Inc.
// All Rights Reserved.
// FeliCa Networks, Inc. Proprietary/Confidential.
//
package com.felicanetworks.falp;

import com.felicanetworks.falp.FalpListener;

/**
 * FALP@\̃C^[tF[XłB
 * <p>
 * {C^[tF[X͕̃vZX瓯ɗp邱Ƃ͂ł܂B<br>
 * vZXFeliCa`bvɗp̏ꍇA
 * YvZXȊÕ\bhĂяoׂ͂ăZLeBG[ƂȂ܂B<br>
 * <p>
 * \bȟĂяoʂ͖߂lA܂́A{@link FalpListener}Œʒm܂B
 * <p>
 * FALPC^tF[X̗pɂẮAʏAndroid ServiceƓA
 * bind{@link IFalpService.Stub#asInterface(android.os.IBinder)}ɂ
 * CX^X()擾A\bhĂяoĂB<br>
 * <p>
 * bindɗpCegAction,Category{@link FalpServiceConst}
 * `Ă܂B
 */
interface IFalpService {
    /**
     * FALPJnv\bhłB
     * <p>
     *  InitiatorƂFALPʐMJnۂɌĂяo܂B
     *  <p>
     *  {\bh́ÃvZXFeliCa`bv𗘗pĂꍇɂ͗pł܂B<br>
     *  ̃vZXɂFeliCa`bvɗpłꍇA
     *  {@link FalpServiceConst#FALP_RTN_SECURITY_ERROR}ԋp܂B<br>
     *  <p>
     *  {@link IFalpService#setFalpAcceptanceListener(FalpListener listener, byte[] appIdentifier)}Ăяo̓
     *  {@link IFalpService#setFalpAcceptanceListener(FalpListener listener, byte[] appIdentifier)}QƂĂB<br>
     * @param listener FALPʐMԒʒmpXi
     * @param appIdentifier AvP[Vʎq
     * @return s<br>
     *            {@link FalpServiceConst#FALP_RTN_OK}... Ăяo<br>
     *            {@link FalpServiceConst#FALP_RTN_ILLEGAL_ACCESS_ERROR}... sȃANZXG[<br>
     *            {@link FalpServiceConst#FALP_RTN_INVALID_PARAM_ERROR}... <code>null</code>łA܂appIdentifier̃TCYK؂Ȓl(=8)ł͂Ȃ<br>
     *            {@link FalpServiceConst#FALP_RTN_SECURITY_ERROR}... ̃vZXFeliCa`bv𗘗pł<br>
     *            {@link FalpServiceConst#FALP_RTN_STATE_ERROR}... ĂяoȂԂł<br>
     *            {@link FalpServiceConst#FALP_RTN_UNKNOWN_ERROR}... m̃G[ɂFALPʐMI<br>
     */
   int startInitiatorFalp( FalpListener listener, in byte[] appIdentifier );

   /**
    * FALPJn\bhłB
    * <p>
    * TargetƂē삷MFCɂċNꂽAvP[VFALPʐM̊JnꍇɌĂяo܂B<br>
    * {\bȟĂяoɁAFALPʐMJn܂B<br>
    * <p>
    * {\bh́AInitiatorFALPJnvɂāA
    * Target̃AvP[VIntentɂNꂽہA܂́A
    * {@link FalpListener#receivedFalpHandshake()}ĂяoꂽԂŌĂяo\łB<br>
    * ̑̏ԂŖ{\bhĂяoꍇA{@link FalpServiceConst#FALP_RTN_STATE_ERROR}ԋp܂B <br>
    * <p>
    * {\bȟĂяoɁAFALPʐM͔񓯊ŎsAAvP[Vɂ͈œn
    * {@link FalpListener}ĒʐMԂʒm܂B<br>
    * <p>
    *
    * @param listener FALPʐMԒʒmXi
    * @param pswd intentŒʒm^CpX[h {@link FalpServiceConst#ONE_TIME_PSWD}<br>
    * AA{@link FalpListener#receivedFalpHandshake}_@ɂďȍꍇA{w͖܂B
    * @return s<br>
     *            {@link FalpServiceConst#FALP_RTN_OK}... Ăяo<br>
     *            {@link FalpServiceConst#FALP_RTN_ILLEGAL_ACCESS_ERROR}... sȃANZXG[<br>
     *            {@link FalpServiceConst#FALP_RTN_INVALID_PARAM_ERROR}... listener<code>null</code>ł<br>
     *            {@link FalpServiceConst#FALP_RTN_SECURITY_ERROR}... ̃vZXFeliCa`bv𗘗pł<br>
     *            {@link FalpServiceConst#FALP_RTN_STATE_ERROR}...  ĂяoȂԂł<br>
    *
    */
   int acceptTargetFalp(FalpListener listener, int pswd);

   /**
    * FALPMv\bhłB
    * <p>
    * FALPʐM𗘗pAf[^̑Mv郁\bhłB<br>
    * {\bhA_ł́Af[^̑MłƂӖA
    * ۂɑΌFeliCaΉ[ɑMĂ邱Ƃ͕ۏ؂܂B<br>
    * {\bhFALPʐMʒm({@link  FalpListener#proposedInitiatorFalp()})ĂяoꂽォĂяoƂ\ŁA<br>
    * FALPʐMʒmOɖ{\bhs邱ƂŁAFALPʐMʒmɑɃf[^𑗐M邱Ƃ\łB
    * <p>
    * {\bȟĂяoɐꍇA߂lƂđMłf[^TCY(byte)Ԃ܂B<br>
    * {\bȟĂяoɎsꍇA߂lƂăG[\0ȉ̒lԋp܂B<br>
    * <p>
    * ǉŃf[^̑Mvꍇ́AM\ȏԂɂȂƂ\{@link FalpListener#sendDataPrepared(int emptySize)}
    * ĂяoꂽɁAĂі{\bhĂяoĂB<br>
    * @param data Mf[^
    * @return s<br>
    *         l - Młf[^TCY<br>
    *         {@link FalpServiceConst#FALP_RTN_BUFFER_FULL_ERROR}...Mobt@ɋ󂫂Ȃ<br>
    *         {@link FalpServiceConst#FALP_RTN_INVALID_PARAM_ERROR}... data<code>null</code>ł<br>
    *         {@link FalpServiceConst#FALP_RTN_SECURITY_ERROR}... ̃vZXFeliCa`bv𗘗pł<br>
    *         {@link FalpServiceConst#FALP_RTN_SEND_DATASIZE_OVER}... ̃f[^TCY傫<br>
    *         {@link FalpServiceConst#FALP_RTN_STATE_ERROR}...  ĂяoȂԂł<br>
    */
   int sendData(in byte[] data);

   /**
    * FALPI\bhłB
    * <p>
    * FALPʐMI郁\bhłB<br>
    * {\bhĂяoƁAMFC͈ȉ̏񓯊Ŏ{܂B<br>
    * (1)Mobt@̃f[^ΌFeliCaΉ[ɑM<br>
    * (2)Mobt@ɂȂ^C~OőΌFeliCaΉ[FALPʐM̏Iʒm<br>
    * (3)FALPʐMJnȌԂɑJ<br>
    * (4){@link FalpListener#shutdownFalpCompleted(int shutdownType, int chipState)}̌Ăяo<br><p>
    * TargetƂē삷ꍇA{\bh{@link FalpListener#recvDataNotify(byte[] recvData, int len)}ÁA
    * {@link FalpListener#sendDataPrepared(int emptySize)}̃XǐĂяoȍ~ɁAĂяoĂB
    * {@link IFalpService#acceptTargetFalp(FalpListener, int)}̌Ăяo
    * {\bhĂяoƁA{@link FalpServiceConst#FALP_RTN_STATE_ERROR}\܂B
    * <p>
    * I̊{@link FalpListener#shutdownFalpCompleted(int shutdownType, int chipState)}Ōm܂B<br>
    * @return s<br>
    *            {@link FalpServiceConst#FALP_RTN_OK}... Ăяo<br>
     *           {@link FalpServiceConst#FALP_RTN_SECURITY_ERROR}... ̃vZXFeliCa`bv𗘗pł<br>
     *           {@link FalpServiceConst#FALP_RTN_STATE_ERROR}... ĂяoȂԂł<br>
    */
   int terminateFalp();

    /**
    * FALPJnۃ\bhłB
    * <p>
    * TargetƂē삷MFCɂċNꂽAvP[VFALPʐM̊JnۂꍇɌĂяo܂B<br>
    * {\bhĂтƁAInitiatorɑ΂FALPʐMI邱Ƃʒm܂B<br>
    * <p>
    * {\bh́AInitiatorFALPJnvɂāA
    * Target̃AvP[VIntentɂNꂽہA܂́A
    * {@link FalpListener#receivedFalpHandshake()}ĂяoꂽԂł̂݌Ăяo\łB<br>
    * ̑̏ԂŖ{\bhĂяoꍇA{@link FalpServiceConst#FALP_RTN_STATE_ERROR}ԋp܂B <br>
    * <p>
    * {\bȟĂяoAAvP[VServiceƂ̐ڑKؒfĂB <br>
    * @param pswd intentŒʒm^CpX[h {@link FalpServiceConst#ONE_TIME_PSWD}<br>
    * AA{@link FalpListener#receivedFalpHandshake}_@ɂďȍꍇA{w͖܂B
    * @return  <br>
     *            {@link FalpServiceConst#FALP_RTN_OK}... Ăяo<br>
     *            {@link FalpServiceConst#FALP_RTN_ILLEGAL_ACCESS_ERROR}... sȃANZXG[<br>
     *            {@link FalpServiceConst#FALP_RTN_SECURITY_ERROR}... ̃vZXFeliCa`bv𗘗pł<br>
     *            {@link FalpServiceConst#FALP_RTN_STATE_ERROR}... ĂяoȂԂł<br>
    */
   int rejectTargetFalp(int pswd);

    /**
    * FALPf\bhłB
    * <p>
    * FALPʐM𑦎ɋI郁\bhłB<br>
    * {\bhĂяoƁAFALPʐM(MAM̏ꍇ)Iɒf܂B<br>
    * {\bh̎sɂ́AMFCFALPʐMJnȌԂɖ߂܂B<br>
    * ȂAΌFeliCaΉ[ɑ΂āAFALPʐM𒆒fƂ͒ʒm܂B<br>
    * <p>
    * ߂l{@link FalpServiceConst#FALP_RTN_NEED_TO_CHIP_CLOSE_ERROR}̏ꍇA
    * FALPfɂ͐Ă܂AFeliCa`bṽZbgɎsĂ܂B<br>
    * <p>
    * @return  <br>
    *            {@link FalpServiceConst#FALP_RTN_OK}... Ăяo<br>
    *            {@link FalpServiceConst#FALP_RTN_NEED_TO_CHIP_CLOSE_ERROR}... ʓrFeliCa`bvN[YA܂̓ZbgKv<br>
    *            {@link FalpServiceConst#FALP_RTN_SECURITY_ERROR}... ̃vZXFeliCa`bv𗘗pł<br>
    *            {@link FalpServiceConst#FALP_RTN_STATE_ERROR}... ĂяoȂԂł<br>
    */
   int cancelFalp();

    /**
    * FALPJnvXio^\bhłB
    * <p>
    * I[vԁ^N[YԂɂāATargetƂInitiatorFALPJnvM邽߂̃Xio^܂B
    * <p>
    * AvP[VɂFeliCa`bv̗pJnĂԂɂāAftHgłTargetƂFALPʐMs邱Ƃ͂ł܂(*)A
    * {\bhs邱ƂTargetƂFALPʐMs邱Ƃł悤ɂȂ܂B<br>
    * (*) InitiatorƂFALPʐMs邱Ƃ͉\łB<br><p>
    * 
    * I[v^N[YԂɂāATargetƂFALPʐMJn邽߂ɂ́A{\bhĂяoAXio^ĂKv܂B<br><p>
    * {\bhɂ胊XiݒsԂŁA{\bhŎw肵AvP[Vʎq܂InitiatorFALPJnvMꍇA
    * {@link FalpListener#receivedFalpHandshake()}Ăяo܂B<br>
    * ̌A{\bȟĂяoɈœnXi{@link FalpListener}ĒʐMԂʒm܂B
    * <p>
    * ɃXiݒ肳ĂԂŖ{\bhĂяoƁAɐݒ肳ĂXiύX邱Ƃł܂B<br>
    * ܂AXi<code>null</code>ݒ肵A{\bhĂяoƂŁAݒς݂̃Xi̓o^邱Ƃł܂B<br>
    * <p>
    * ߂l{@link FalpServiceConst#FALP_RTN_NEED_TO_CHIP_CLOSE_ERROR}̏ꍇA
    * FeliCa`bṽZbgAуXi̐ݒɎsĂ܂̂ŁAēx{\bhsĂB<br>
    * <p>
    * @param listener FALPʐMԒʒmXi
    * @param appIdentifier AvP[Vʎq
    * @return  <br>
     *            {@link FalpServiceConst#FALP_RTN_OK}... Ăяo<br>
     *            {@link FalpServiceConst#FALP_RTN_ILLEGAL_ACCESS_ERROR}... sȃANZXG[<br>
     *            {@link FalpServiceConst#FALP_RTN_INVALID_PARAM_ERROR}... appIdentifier<code>null</code>łA܂appIdentifier̃TCYK؂Ȓl(=8)ł͂Ȃ<br>
     *            {@link FalpServiceConst#FALP_RTN_NEED_TO_CHIP_CLOSE_ERROR}... ʓrFeliCa`bvN[YA܂̓ZbgKv<br>
     *            {@link FalpServiceConst#FALP_RTN_SECURITY_ERROR}... ̃vZXFeliCa`bv𗘗pł<br>
     *            {@link FalpServiceConst#FALP_RTN_STATE_ERROR}... ĂяoȂ(ICA܂́AFALPʐM)ł<br>
    */
   int setFalpAcceptanceListener(FalpListener listener, in byte[] appIdentifier);
    /**
     * ő呗Mobt@擾\bhłB
     * <p>
     * 1xɑM\ȃf[^̍őTCYԋp܂B<br>
     * {\bhŎ擾\ȒĺA1őMłTCYĂ邽߁A
     * FALPʐM(ʐMJnI܂)ɑMłőTCYł͂ȂƂɒӂĂB<br>
     * (ʐMŜʂĂɑMłTCYɐ͂܂)<br>
     * <p>
    * @return s<br>
    *         0ȏ̒l - ő呗Mobt@TCY<br>
    *         {@link FalpServiceConst#FALP_RTN_SECURITY_ERROR}... ̃vZXFeliCa`bv𗘗pł<br>
     */
    int getMaxSendSize();
    /**
     * őMobt@擾\bhłB
     * <p>
     * 1xɃAv֒ʒmf[^̍őTCYԋp܂B<br>
     * {\bhŎ擾\ȒĺA1ŎMłTCY\Ă邽߁A
     * FALPʐM(ʐMJnI܂)ɎMłőTCYł͂ȂƂɒӂĂB<br>
     * (ʐMŜʂĂɎMłTCYɐ͂܂)<br>
     * <p>
    * @return s<br>
    *         0ȏ̒l - őMobt@TCY<br>
    *         {@link FalpServiceConst#FALP_RTN_SECURITY_ERROR}... ̃vZXFeliCa`bv𗘗pł<br>
     */
    int getMaxReceiveSize();
   /*(JavaDoc)*/
   int recvStartCheckYES();
   /*(JavaDoc)*/
   int recvStartCheckNO();
   /*(JavaDoc)*/
   int startInitiatorFalpInner(FalpListener listener, in byte[] appCode, int pid, int uid);
}
